package com.jiopay.flutter_jiopay_pg;

import androidx.annotation.NonNull;

import java.util.Map;

import io.flutter.Log;
import io.flutter.embedding.engine.plugins.FlutterPlugin;
import io.flutter.embedding.engine.plugins.activity.ActivityAware;
import io.flutter.embedding.engine.plugins.activity.ActivityPluginBinding;
import io.flutter.plugin.common.MethodCall;
import io.flutter.plugin.common.MethodChannel;
import io.flutter.plugin.common.MethodChannel.MethodCallHandler;
import io.flutter.plugin.common.MethodChannel.Result;
import io.flutter.plugin.common.PluginRegistry;

/** FlutterJiopayPgPlugin */
public class FlutterJiopayPgPlugin implements FlutterPlugin,  MethodCallHandler, ActivityAware {

  private MethodChannel channel;
  private static String CHANNEL_NAME = "flutter_jiopay_pg";
  @Override
  public void onAttachedToEngine(@NonNull FlutterPluginBinding flutterPluginBinding) {
    channel = new MethodChannel(flutterPluginBinding.getBinaryMessenger(), CHANNEL_NAME);
    channel.setMethodCallHandler(this);
  }



  @Override
  public void onDetachedFromEngine(@NonNull FlutterPluginBinding binding) {
    channel.setMethodCallHandler(null);
  }


  private JiopayDelegate jiopayDelegate;




  public FlutterJiopayPgPlugin() {

  }

  /**
   * Plugin registration for Flutter version < 1.12
   */
  public static void registerWith(PluginRegistry.Registrar registrar) {
    final MethodChannel channel = new MethodChannel(registrar.messenger(), CHANNEL_NAME);
    channel.setMethodCallHandler(new FlutterJiopayPgPlugin(registrar));
  }






  /**
   * Constructor for Flutter version < 1.12
   * @param registrar
   */
  private FlutterJiopayPgPlugin(PluginRegistry.Registrar registrar) {
    this.jiopayDelegate = new JiopayDelegate(registrar.activity());

  }

  @Override
  @SuppressWarnings("unchecked")
  public void onMethodCall(MethodCall call, Result result) {
    switch (call.method) {

      case "open":
        jiopayDelegate.openCheckout((Map<String, Object>) call.arguments, result);
        break;
      case "resync":
        jiopayDelegate.resync(result);
        break;
      default:
        result.notImplemented();

    }


  }

  @Override
  public void onAttachedToActivity(@NonNull ActivityPluginBinding binding) {
    this.jiopayDelegate = new JiopayDelegate(binding.getActivity());


  }

  @Override
  public void onDetachedFromActivityForConfigChanges() {
    onDetachedFromActivity();
  }

  @Override
  public void onReattachedToActivityForConfigChanges(@NonNull ActivityPluginBinding binding) {
    onAttachedToActivity(binding);
  }

  @Override
  public void onDetachedFromActivity() {

  }
}
